package com.company.jmixreports154.screen.user;

import com.company.jmixreports154.entity.User;
import com.haulmont.yarg.reporting.ReportOutputDocument;
import io.jmix.reports.runner.ReportRunner;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.Button;
import io.jmix.ui.download.Downloader;
import io.jmix.ui.navigation.Route;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("User.browse")
@UiDescriptor("user-browse.xml")
@LookupComponent("usersTable")
@Route("users")
public class UserBrowse extends StandardLookup<User> {

    @Autowired
    private ReportRunner reportRunner;
    @Autowired
    private Notifications notifications;
    @Autowired
    private Downloader downloader;

    @Subscribe("reportBtn")
    public void onReportBtnClick(final Button.ClickEvent event) {
        ReportOutputDocument document = reportRunner.byReportCode("user-list")
                .run();

        byte[] reportContent = document.getContent();
        String reportName = document.getDocumentName();

        downloader.download(reportContent, reportName);

        notifications.create(Notifications.NotificationType.TRAY)
                .withCaption("Report - Done!")
                .show();
    }
}